;*****************************************************************************
;HKATTA.lsp
;Bentigt HKATTAR.dwg , HKATTAF.dwg , HOCH.shx , Layer BEM
;(C) Copyright Konstruktionsbro W. MEYER, D-85649 Otterloh,        16.12.2002       
;*****************************************************************************
(defun c:Kot_Hoehe_S (/ )
 (princ "\nH'koten setzen.  Starten mit HKATTA ")
;*****************************************************************************
;FEHLERBEHANDLUNGSROUTINE.....................................................
 (defun-q *error* (msg)
  (setvar "osmode" aosm)  (setvar "luprec" alup) (setvar "dimzin" azin)
  (setq p1 nil p2 nil p3 nil p4 nil c1 nil cy nil cym nil txt nil)
  (setq hkmz nil o_str nil n_str nil o_slen nil n_slen nil si nil st nil dx nil me nil cmmm nil cm1 nil cm2 nil mm1 nil mm2 nil txtme nil txtcm nil txtmm nil cym nil)
  (setq asatz nil len nil n nil e nil e1 nil)
  (setq o_str nil n_str nil o_slen nil n_slen nil si nil st nil)
  (if (= hka nil) (setq hka hkwa) (setq hkwa hka) )
  (princ msg)(princ)
 )
;*****************************************************************************
;SYSTEMVARIABLEN SETZEN.......................................................
 (while (or (= mxy nil)(= mxy 0)(= mxy 0.0))
    (initget "10 20 25 50 100")
   (setq mxy (getreal "\n Mastab [10/20/25/50/100]"))
  (princ "\n\n\n")
 )
 (setq aosm (getvar "osmode"))
 (setq alup (getvar "luprec"))
 (setq azin (getvar "dimzin"))
 (setvar "cmdecho" 0)
 (setvar "osmode" 111)
 (HK-WAHL)
 (setvar "osmode" aosm)  (setvar "luprec" alup) (setvar "dimzin" azin)
 (princ)
)
;*****************************************************************************
;SYSTEMVARIABLEN SETZEN.......................................................
 (defun HK-SYS (/ )
    (initget "10 20 25 50 100")
   (setq mxy (getreal "\n Mastab [10/20/25/50/100]"))
  (princ "\n\n\n")
 )
;*****************************************************************************
;Basispunkt und Basishhe setze...............................................
(defun HK-WAHL (/ )
 (if (or (= NPKT nil)(= NPKT "")) (HK-NPKT) (progn (HK-AKREUZ)(HK-BEZUG)) )
 (if (= hka nil) (setq hka "S" hkwa hka) )
 (initget "S A M B")
 (setq hka (getkword (strcat "\n[Setzen/Aktualisieren/Bezugspunkt/Mastab]  <" hka "> ?: ")) )
  (if (= hka "M")
  (progn
   (setq hka hkwa) (HK-SYS)
   (initget "S A M B")
   (setq hka (getkword (strcat "\n[Setzen/Aktualisieren/Bezugspunkt/Mastab]  <" hka "> ?: ")) )
  )
 )
(if (= hka "B")
  (progn
   (setq hka hkwa) (HK-NPKT)
   (initget "S A M B")
   (setq hka (getkword (strcat "\n[Setzen/Aktualisieren/Bezugspunkt/Mastab]  <" hka "> ?: ")) )
  )
 )
 (if (= hka "A")
  (progn
   (setq hka hkwa) (HK-AKTUEL)
   (initget "S A M B")
   (setq hka (getkword (strcat "\n[Setzen/Aktualisieren/Bezugspunkt/Mastab]  <" hka "> ?: ")) )
  )
 )  
 (if (= hka nil) (setq hka hkwa) (setq hkwa hka) )
 (if (or (= hka "R")(= hka "S")) (HK-SETZEN) )
 (setvar "osmode" aosm)  (setvar "luprec" alup) (setvar "dimzin" azin)
 (princ)
)
;*****************************************************************************
;BEZUGSPUNKT- BEZUGSWERT- FESTLEGEN...........................................
(defun HK-NPKT (/ )
 (command "_redraw")
 (princ "\n\n\n")
 (setq pxy nil)
 (while (or (= pxy nil)(= pxy ""))
  (setq pxy (getpoint "\nBezugspunkt whlen: "))
   (princ "\n\n\n\n")
 )
 (HK-AKREUZ)
 (setq py nil)
 (while (or (= py nil)(= py ""))
  (setq py (getreal "\nBezugspunkt Hhe ?: ")) 
  (princ "\n\n\n")
 )
 (setq tpya py)						;fr Bezugswert-Anzeige
 (setq NPKT (cadr pxy) NPKT (- NPKT py))
 (princ "\n\n\n")
 (HK-BEZUG)
 (princ)
)
;*****************************************************************************
;BEZUGSPUNKT-WERT ANZEIGEN....................................................
(defun HK-BEZUG (/ )
 (if (or (= py 0.0)(= py 0)) (setq tpya (strcat "+/-" (rtos py))) )
 (if (or (> py 0.0)(> py 0)) (setq tpya (strcat "+" (rtos py))) )
 (princ "\nDer aktuelle Bezugspunkt liegt auf: ")(princ tpya)
 (princ)
)
;*****************************************************************************
;ACHSKREUZ AM BEZUGSPUNKT ZEICHNEN............................................
(defun HK-AKREUZ (/ p1 p2 p3 p4)
 (command "_redraw")
 (setq p1 (list (car pxy) (cadr (getvar "VSMIN")) )
       p2 (list (car pxy) (cadr (getvar "VSMAX")) )
       p3 (list (car (getvar "VSMIN")) (cadr pxy) )
       p4 (list (car (getvar "VSMAX")) (cadr pxy) )
 )
 (grvecs (list 2 p1 p2 2 p3 p4))
 (princ)
)
;*****************************************************************************
;BLOCK EINFGEN...............................................................
(defun HK-SETZEN (/ c1 cy cym txt)
 (princ "\n\nH'kote wird am gewhlten Punkt eingefgt. ")
  (while
  (setq c1 (getpoint "\nH'koten-Punkt whlen: ") )
  (setq cy (cadr c1) cy (- cy NPKT))
  
  ;(setq cy (/ cy 1000))				;Aktivieren wenn: gezeichnet in "m"
  ;(setq cy (/ cy 100))					;Aktivieren wenn:
  ;(setq cy (/ cy 10))					;Aktivieren wenn: gezeichnet in "cm"

  (setq cym cy)
  (if (minusp cy) (setq cy (* -1 cy)) )
  (setq txt (rtos cy))
  (Architektur)
  (if (= hka "S")(command "_-insert" "Kot_Hoehe_S" c1 mxy "" "" txt) )
  (princ txt)
 )
 (princ)
)
;=============================================================================
(defun Architektur (/ hkmz o_str n_str o_slen n_slen si st dx me cmmm cm1 cm2 mm1 mm2 txtme txtcm txtmm)
 (setq HKMZ 3)						;mm Darstellung HKMZ 3=nur ganze mm HKMZ 4=auch 1/10mm
 (setvar "luprec" HKMZ)					;3- oder 4-Nachkommastellen
 (setvar "dimzin" 0)					;0.0000 Ja
;Beginn suche nach Komma ersetze durch Punkt
 (setq o_str ",")(setq n_str ".")
 (setq o_slen (strlen o_str))
 (setq n_slen (strlen n_str))
 (setq si 1)
 (while (= o_slen (strlen (setq st (substr txt si o_slen))))
  (if (= st o_str)
   (progn
    (setq txt (strcat
               (if (> si 1) (substr txt 1 (1- si)) "" )
               n_str (substr txt (+ si o_slen))
    )         )
    (setq si (+ si n_slen))
   )
   (setq si (1+ si))
  )
 )
;Ende suche nach Komma ersetze durch Punkt
 (setq DX (atof txt))					;"12,3456" ergibt 12.3456
 (setq DX (/ DX 100))					;=.123456  m
 (setq me (float (fix DX)))				;=12.0000  m
 (setq cmmm (- DX me))					;=0.3456   m
 (setq me (rtos me 2 0))				;"12"      m
 (setq cmmm (rtos  cmmm 2 HKMZ))			;"0.3456"  m
 (setq cm1 (substr cmmm 3 1))				;="3"      cm1
 (setq cm2 (substr cmmm 4 1))				;="4"      cm2
 (setq mm1 (substr cmmm 5 1))				;="5"      mm1
 (setq mm2 (substr cmmm 6 1))				;="6"      mm2
;METER
 (if (>= (read me) 1)
  (setq txtme (strcat me ","))				;"12,"     m, (nach Meter ein Komma)
  (setq txtme "0,")					;""        nichts
 )
;ZENTIMETER
 (if (> (read cm1) 0)
  (setq txtcm (strcat cm1 cm2))				;"34"      cm
  (setq txtcm (strcat "0" cm2))				;"04"       cm
 )
 (if (>= (read me) 1)
  (setq txtcm (strcat cm1 cm2))				;"34"      cm
 )
 (if (and (< (read me) 1)(= (read cm1) 0)(= (read cm2) 0)
          (or (> (read mm1) 0)(> (read mm2) 0) )
     )
  (setq txtcm "00")					;"0"       cm
 )
;MILLIMETER
 (if (= HKMZ 4) (setq k ",") (setq k "" mm2 "" ) )
 (if (= (read mm2) 0) (setq k "" mm2 "" ) )
 (if (= HKMZ 4)
  (setq txtmm (strcat mm1 k mm2))			;"5,6"     mm 2-Stellig mit Komma
  (setq txtmm mm1)					;"5"       mm 1-Stellig
 )
 (if (and (or (= (read mm1) 0)(= mm1 "")) (or (= (read mm2) 0)(= mm2 "")) )
  (setq txtmm "")					;""        nichts
 )
;ZUSAMMENSTELLUNG DER ARCHITEKTUR-ZAHL
 (setq txt (strcat txtme txtcm ))		;, = hochstellen mit Alt190
 (if (or (= cym 0.0)(= cym 0)) (setq txt (strcat "" txt )) )
 (if (or (> cym 0.0)(> cym 0)) (setq txt (strcat "+" txt)) )
 (if (minusp cym) (setq txt (strcat "-" txt)) )
 (princ)
)
;*****************************************************************************
;HK-AKTUEL.lsp.......................... .....................................
;AKTUALISIERT H'KOTEN-BLCKE auf den aktuellen Y-Wert des Einfgepunktes      
;Anhngende Texte werden entfernt: z.B. wird aus +1000 O.K.S. dann +1222      
;.........................................................................  ..
(defun HK-AKTUEL (/ asatz len n c1 e cy txt e1)
 (command "_undo" "m")					;Zurck Markierung
 (if (= meld nil) (MELDSTA) )
 (princ "\n\n\nDas Programm aktualisiert die Werte gewhlter H'koten. ")
 (setq asatz (ssget (list (cons -4 "<or")
                          (cons 2 "Kot_Hoehe_S");Blcke whlen
                          (cons -4 "or>")
             )      )		
         len (sslength asatz)				;Lnge Auswahlsatz
           n 0						;Anzahl Elemente im Auswahlsatz
 )
 (while (< n len)
  (setq e (entget (ssname asatz n)) )
  (setq c1 (cdr (assoc 10 e)) qe c1)			;Basis c1 = WKS xyz Koordinaten
  (setq c1 (trans c1 0 1))				;jetzt c1 = BKS xyz Koordinaten
  (setq cy (cadr c1) cy (- cy NPKT) )
  
  ;(setq cy (/ cy 1000))				;Aktivieren wenn: gezeichnet in "m"
  ;(setq cy (/ cy 100))					;Aktivieren wenn:
  ;(setq cy (/ cy 10))					;Aktivieren wenn: gezeichnet in "cm"
  
  (setq cym cy)
  (if (minusp cy) (setq cy (* -1 cy)) )
  (setq txt (rtos cy))
  (Architektur)
  (setq e1 (entget (entnext (cdr (assoc -1 e)))) )
  (setq e1 (subst (cons 1 txt)(assoc 1 e1) e1) )
  (entmod e1)
  (entupd (cdr (assoc -1 e1)))
  (setq n (1+ n))
 )							;ende-while
 (princ "\n\n\n")
)							;ende-defun
;*****************************************************************************
;MELDUNG NUR BEIM START.......................................................
(defun MELDSTA (/ )
(alert "
\Auch von Hand genderte Zahlen
\ ndern sich auf den Wert der
\      aktuellen Position"
)
(setq meld 1)
(princ)
)
;*****************************************************************************
